<?PHP

class wmset
{


    var $sets = array(array());
    var $mult = 0.0000095;
    var $pers = 30;
    var $wheel_bonus = '';

    public function __construct($config = '')
    {

        if ($config == '') {
            # Настройка стоимости деревьев! По порядку!
            $this->sets[1]["t_a"] = 5;
            $this->sets[1]["t_b"] = 25;
            $this->sets[1]["t_c"] = 100;
            $this->sets[1]["t_d"] = 500;
            $this->sets[1]["t_e"] = 1000;
        }else{
            $this->sets[1]["t_a"] = $config['amount_a_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_b"] = $config['amount_b_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_c"] = $config['amount_c_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_d"] = $config['amount_d_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_e"] = $config['amount_e_t'] / $config['ser_per_wmr'];

            $this->pers = intval($config['wmset_pers']);   
            $this->mult = floatval($config['wmset_mult']);

            $this->wheel_bonus = $config['wheel_bonus'];
        }

    }


    function SetsList()
    {

        unset($this->sets[0]);
        return $this->sets;

    }


    function GetSet($sum)
    {
        $money = abs(floatval($sum));

        if(intval($money) > 50000) $money = 50000;

        $sum = intval(($money + 1) * (($this->pers / 100) + ($money * $this->mult)));

        #if ($sum < 20) return false;

        $ret_tree = array();

        while (true) {


            if (($sum * 0.7) >= $this->sets[1]["t_e"]) {

                $sum = $sum - $this->sets[1]["t_e"];
                $ret_tree["t_e"] = $ret_tree["t_e"] + 1;

            } elseif (($sum * 0.7) >= $this->sets[1]["t_d"]) {

                $sum = $sum - $this->sets[1]["t_d"];
                $ret_tree["t_d"] = $ret_tree["t_d"] + 1;

            } elseif (($sum * 0.7) >= $this->sets[1]["t_c"]) {

                $sum = $sum - $this->sets[1]["t_c"];
                $ret_tree["t_c"] = $ret_tree["t_c"] + 1;

            } elseif (($sum * 0.7) >= $this->sets[1]["t_b"]) {

                $sum = $sum - $this->sets[1]["t_b"];
                $ret_tree["t_b"] = $ret_tree["t_b"] + 1;

            } elseif ($sum >= $this->sets[1]["t_a"]) {

                $sum = $sum - $this->sets[1]["t_a"];
                $ret_tree["t_a"] = $ret_tree["t_a"] + 1;

            } else break;

        }

        if($this->wheel_bonus != ''){
            $ret_tree["wheel"] = 0;
            $ws = explode(';',$this->wheel_bonus);
            foreach($ws as $item){
                $data = explode(":",$item);
                if($data[0] <= 0 && $data[1] <= 0) break;
                if($money >= $data[0]){
                    $ret_tree["wheel"] = $data[1];
                }
            }
        }else{
            $ret_tree["wheel"] = 0;
        }

        return $ret_tree;
    }

}


?>